/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUMOTC_MOTIVOCANC                                           */
/* Tabela : MOTIVOCANC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATUMOTC_MOTIVOCANC' and
            type = 'TR'                        and
            u.uid = o.uid           	       and
            u.name = USER)
   DROP TRIGGER DTULTATUMOTC_MOTIVOCANC
GO

CREATE TRIGGER DTULTATUMOTC_MOTIVOCANC
ON MOTIVOCANC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'MOTIVOCANC', null, 'CDMOTICANC=' + CDMOTICANC + ';',                               GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE MOTIVOCANC
      SET DTULTATUMOTC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(MOTIVOCANC.CDMOTICANC,0) = ISNULL(INSERTED.CDMOTICANC,0 )) AND                                      (ISNULL(MOTIVOCANC.DSMOTICANC,0) = ISNULL(INSERTED.DSMOTICANC,0));
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATUMOTC_MOTIVOCANC','4.11.072';
GO

