IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME  = 'USR_BLOQ_EXCLUIR_SOLICITA_APROV' AND
      	          TYPE   = 'TR' 			                    AND
	                U.UID  = O.UID                             AND
      	          U.NAME = USER)

   DROP TRIGGER USR_BLOQ_EXCLUIR_SOLICITA_APROV
GO

CREATE TRIGGER USR_BLOQ_EXCLUIR_SOLICITA_APROV ON ITEMSOLI
FOR DELETE
AS
   DECLARE @V_DSREMOTEADDR  VARCHAR(15);
   DECLARE @V_DSREMOTEHOST  VARCHAR(15);
   DECLARE @V_DSSERVERRDM   VARCHAR(20);
   DECLARE @V_DSSERVMETHOD  VARCHAR(30);
   DECLARE @V_DSREMOTEOPER  VARCHAR(12);

   DECLARE @OLD_CDFILSOLI   VARCHAR(4);
   DECLARE @OLD_CDFILLAN    VARCHAR(4);
   DECLARE @OLD_NRSOLICMP   VARCHAR(10);
   DECLARE @OLD_IDSOLIAPROV VARCHAR(01);

   DECLARE @V_TIPO          VARCHAR(01);
   DECLARE @V_DESC          VARCHAR(500);
   
   DECLARE @V_COUNT         INT;
BEGIN
   SET @V_COUNT = 0;

   EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                   @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                   @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                   @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                   @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'D' IDCOMANDO,
             DELETED.CDFILSOLI,
             DELETED.CDFILLAN,
             DELETED.NRSOLICMP,
             ISNULL((SELECT MAX(IDSOLIAPROV)
                       FROM DELETED
                      WHERE 0 = (SELECT COUNT(*)
                                   FROM INSERTED)
                        AND DELETED.IDSOLIAPROV = 'S'),'N') IDSOLIAPROV
        FROM DELETED
       WHERE 0 = (SELECT COUNT(*)
                    FROM INSERTED)
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_TIPO,
                                 @OLD_CDFILSOLI,
                                 @OLD_CDFILLAN,
                                 @OLD_NRSOLICMP,
                                 @OLD_IDSOLIAPROV;                                    
   WHILE (@@FETCH_STATUS = 0) BEGIN
            SELECT @V_COUNT = COUNT(1)
              FROM ITEMSOLI
             WHERE IDSOLIAPROV = 'S'
               AND NRSOLICMP   = @OLD_NRSOLICMP
               AND CDFILSOLI   = @OLD_CDFILSOLI
               AND CDFILLAN    = @OLD_CDFILLAN;

      IF @V_TIPO = 'D' BEGIN
         IF (SUBSTRING(@V_DSSERVERRDM, 1, 15) = 'rdmLancaSoliCmp' ) OR
            (SUBSTRING(@V_DSSERVERRDM, 1, 13) = 'rdmAltSoliCmp'   ) OR
            (SUBSTRING(@V_DSSERVERRDM, 1, 16) = 'rdmAltAutSoliCmp') BEGIN

         IF (@V_COUNT > 0) OR (@OLD_IDSOLIAPROV = 'S')  BEGIN
            SET @V_DESC = 'Operao bloqueada! No  permitido excluir item ou solicitao de compras quando se tem algum item aprovado.';
            RAISERROR(@V_DESC, 16,1);
         END;
      END;
   END;
   FETCH NEXT FROM C_CURSOR INTO @V_TIPO,
                                 @OLD_CDFILSOLI,
                                 @OLD_CDFILLAN,
                                 @OLD_NRSOLICMP,
                                 @OLD_IDSOLIAPROV;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END; 
GO
